(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/coercion'), require('@angular/core'), require('rxjs'), require('@angular/cdk/keycodes'), require('@angular/animations'), require('@angular/cdk/a11y'), require('@angular/common'), require('@angular/cdk/table'), require('rxjs/operators'), require('@angular/cdk/collections')) :
    typeof define === 'function' && define.amd ? define('dfx-bootstrap-table', ['exports', '@angular/cdk/coercion', '@angular/core', 'rxjs', '@angular/cdk/keycodes', '@angular/animations', '@angular/cdk/a11y', '@angular/common', '@angular/cdk/table', 'rxjs/operators', '@angular/cdk/collections'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["dfx-bootstrap-table"] = {}, global.ng.cdk.coercion, global.ng.core, global.rxjs, global.ng.cdk.keycodes, global.ng.animations, global.ng.cdk.a11y, global.ng.common, global.ng.cdk.table, global.rxjs.operators, global.ng.cdk.collections));
})(this, (function (exports, coercion, i0, rxjs, keycodes, animations, i3, i4, i1, operators, collections) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);
    var i4__namespace = /*#__PURE__*/_interopNamespace(i4);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    /** Mixin to augment a directive with an initialized property that will emits when ngOnInit ends. */
    function mixinInitialized(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spreadArray([], __read(args))) || this;
                /** Whether this directive has been marked as initialized. */
                _this._isInitialized = false;
                /**
                 * List of subscribers that subscribed before the directive was initialized. Should be notified
                 * during _markInitialized. Set to null after pending subscribers are notified, and should
                 * not expect to be populated after.
                 */
                _this._pendingSubscribers = [];
                /**
                 * Observable stream that emits when the directive initializes. If already initialized, the
                 * subscriber is stored to be notified once _markInitialized is called.
                 */
                _this.initialized = new rxjs.Observable(function (subscriber) {
                    // If initialized, immediately notify the subscriber. Otherwise store the subscriber to notify
                    // when _markInitialized is called.
                    if (_this._isInitialized) {
                        _this._notifySubscriber(subscriber);
                    }
                    else {
                        _this._pendingSubscribers.push(subscriber);
                    }
                });
                return _this;
            }
            /**
             * Marks the state as initialized and notifies pending subscribers. Should be called at the end
             * of ngOnInit.
             * @docs-private
             */
            class_1.prototype._markInitialized = function () {
                this._isInitialized = true;
                this._pendingSubscribers.forEach(this._notifySubscriber);
                this._pendingSubscribers = null;
            };
            /** Emits and completes the subscriber stream (should only emit once). */
            class_1.prototype._notifySubscriber = function (subscriber) {
                subscriber.next();
                subscriber.complete();
            };
            return class_1;
        }(base));
    }

    function mixinDisabled(base) {
        return /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var _this = _super.apply(this, __spreadArray([], __read(args))) || this;
                _this._disabled = false;
                return _this;
            }
            Object.defineProperty(class_1.prototype, "disabled", {
                get: function () {
                    return this._disabled;
                },
                set: function (value) {
                    this._disabled = coercion.coerceBooleanProperty(value);
                },
                enumerable: false,
                configurable: true
            });
            return class_1;
        }(base));
    }

    /** Injection token to be used to override the default options for `mat-sort`. */
    var MAT_SORT_DEFAULT_OPTIONS = new i0.InjectionToken('MAT_SORT_DEFAULT_OPTIONS');
    // Boilerplate for applying mixins to MatSort.
    /** @docs-private */
    var _NgbSortBase = mixinInitialized(mixinDisabled(/** @class */ (function () {
        function class_1() {
        }
        return class_1;
    }())));
    /** Container for MatSortables to manage the sort state and provide default sort parameters. */
    var NgbSort = /** @class */ (function (_super) {
        __extends(NgbSort, _super);
        function NgbSort(_defaultOptions) {
            var _this = _super.call(this) || this;
            _this._defaultOptions = _defaultOptions;
            /** Collection of all registered sortables that this directive manages. */
            _this.sortables = new Map();
            /** Used to notify any child components listening to state changes. */
            _this._stateChanges = new rxjs.Subject();
            /** The id of the most recently sorted MatSortable. */
            _this.active = '';
            /**
             * The direction to set when an MatSortable is initially sorted.
             * May be overriden by the MatSortable's sort start.
             */
            _this.start = 'asc';
            _this._direction = '';
            _this._disableClear = false;
            /** Event emitted when the user changes either the active sort or sort direction. */
            _this.sortChange = new i0.EventEmitter();
            return _this;
        }
        Object.defineProperty(NgbSort.prototype, "direction", {
            /** The sort direction of the currently active MatSortable. */
            get: function () {
                return this._direction;
            },
            set: function (direction) {
                this._direction = direction;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgbSort.prototype, "disableClear", {
            /**
             * Whether to disable the user from clearing the sort by finishing the sort direction cycle.
             * May be overriden by the MatSortable's disable clear input.
             */
            get: function () {
                return this._disableClear;
            },
            set: function (v) {
                this._disableClear = coercion.coerceBooleanProperty(v);
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Register function to be used by the contained MatSortables. Adds the MatSortable to the
         * collection of MatSortables.
         */
        NgbSort.prototype.register = function (sortable) {
            this.sortables.set(sortable.id, sortable);
        };
        /**
         * Unregister function to be used by the contained MatSortables. Removes the MatSortable from the
         * collection of contained MatSortables.
         */
        NgbSort.prototype.deregister = function (sortable) {
            this.sortables.delete(sortable.id);
        };
        /** Sets the active sort id and determines the new sort direction. */
        NgbSort.prototype.sort = function (sortable) {
            if (this.active != sortable.id) {
                this.active = sortable.id;
                this.direction = sortable.start ? sortable.start : this.start;
            }
            else {
                this.direction = this.getNextSortDirection(sortable);
            }
            this.sortChange.emit({ active: this.active, direction: this.direction });
        };
        /** Returns the next sort direction of the active sortable, checking for potential overrides. */
        NgbSort.prototype.getNextSortDirection = function (sortable) {
            var _a, _b, _c;
            if (!sortable) {
                return '';
            }
            // Get the sort direction cycle with the potential sortable overrides.
            var disableClear = (_b = (_a = sortable === null || sortable === void 0 ? void 0 : sortable.disableClear) !== null && _a !== void 0 ? _a : this.disableClear) !== null && _b !== void 0 ? _b : !!((_c = this._defaultOptions) === null || _c === void 0 ? void 0 : _c.disableClear);
            var sortDirectionCycle = getSortDirectionCycle(sortable.start || this.start, disableClear);
            // Get and return the next direction in the cycle
            var nextDirectionIndex = sortDirectionCycle.indexOf(this.direction) + 1;
            if (nextDirectionIndex >= sortDirectionCycle.length) {
                nextDirectionIndex = 0;
            }
            return sortDirectionCycle[nextDirectionIndex];
        };
        NgbSort.prototype.ngOnInit = function () {
            this._markInitialized();
        };
        NgbSort.prototype.ngOnChanges = function () {
            this._stateChanges.next();
        };
        NgbSort.prototype.ngOnDestroy = function () {
            this._stateChanges.complete();
        };
        return NgbSort;
    }(_NgbSortBase));
    NgbSort.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSort, deps: [{ token: MAT_SORT_DEFAULT_OPTIONS, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbSort.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbSort, selector: "[ngb-sort]", inputs: { disabled: ["ngbSortDisabled", "disabled"], active: ["matSortActive", "active"], start: ["matSortStart", "start"], direction: ["matSortDirection", "direction"], disableClear: ["matSortDisableClear", "disableClear"] }, outputs: { sortChange: "matSortChange" }, host: { classAttribute: "ngb--sort" }, exportAs: ["ngbSort"], usesInheritance: true, usesOnChanges: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSort, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngb-sort]',
                        exportAs: 'ngbSort',
                        host: { 'class': 'ngb--sort' },
                        inputs: ['disabled: ngbSortDisabled'],
                    }]
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Optional
                        }, {
                            type: i0.Inject,
                            args: [MAT_SORT_DEFAULT_OPTIONS]
                        }] }];
        }, propDecorators: { active: [{
                    type: i0.Input,
                    args: ['matSortActive']
                }], start: [{
                    type: i0.Input,
                    args: ['matSortStart']
                }], direction: [{
                    type: i0.Input,
                    args: ['matSortDirection']
                }], disableClear: [{
                    type: i0.Input,
                    args: ['matSortDisableClear']
                }], sortChange: [{
                    type: i0.Output,
                    args: ['matSortChange']
                }] } });
    /** Returns the sort direction cycle to use given the provided parameters of order and clear. */
    function getSortDirectionCycle(start, disableClear) {
        var sortOrder = ['asc', 'desc'];
        if (start == 'desc') {
            sortOrder.reverse();
        }
        if (!disableClear) {
            sortOrder.push('');
        }
        return sortOrder;
    }

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /** @docs-private */
    var AnimationCurves = /** @class */ (function () {
        function AnimationCurves() {
        }
        return AnimationCurves;
    }());
    AnimationCurves.STANDARD_CURVE = 'cubic-bezier(0.4,0.0,0.2,1)';
    AnimationCurves.DECELERATION_CURVE = 'cubic-bezier(0.0,0.0,0.2,1)';
    AnimationCurves.ACCELERATION_CURVE = 'cubic-bezier(0.4,0.0,1,1)';
    AnimationCurves.SHARP_CURVE = 'cubic-bezier(0.4,0.0,0.6,1)';
    /** @docs-private */
    var AnimationDurations = /** @class */ (function () {
        function AnimationDurations() {
        }
        return AnimationDurations;
    }());
    AnimationDurations.COMPLEX = '375ms';
    AnimationDurations.ENTERING = '225ms';
    AnimationDurations.EXITING = '195ms';

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    var SORT_ANIMATION_TRANSITION = AnimationDurations.ENTERING + ' ' + AnimationCurves.STANDARD_CURVE;
    /**
     * Animations used by MatSort.
     * @docs-private
     */
    var ngbSortAnimations = {
        /** Animation that moves the sort indicator. */
        indicator: animations.trigger('indicator', [
            animations.state('active-asc, asc', animations.style({ transform: 'translateY(0px)' })),
            // 10px is the height of the sort indicator, minus the width of the pointers
            animations.state('active-desc, desc', animations.style({ transform: 'translateY(10px)' })),
            animations.transition('active-asc <=> active-desc', animations.animate(SORT_ANIMATION_TRANSITION)),
        ]),
        /** Animation that rotates the left pointer of the indicator based on the sorting direction. */
        leftPointer: animations.trigger('leftPointer', [
            animations.state('active-asc, asc', animations.style({ transform: 'rotate(-45deg)' })),
            animations.state('active-desc, desc', animations.style({ transform: 'rotate(45deg)' })),
            animations.transition('active-asc <=> active-desc', animations.animate(SORT_ANIMATION_TRANSITION)),
        ]),
        /** Animation that rotates the right pointer of the indicator based on the sorting direction. */
        rightPointer: animations.trigger('rightPointer', [
            animations.state('active-asc, asc', animations.style({ transform: 'rotate(45deg)' })),
            animations.state('active-desc, desc', animations.style({ transform: 'rotate(-45deg)' })),
            animations.transition('active-asc <=> active-desc', animations.animate(SORT_ANIMATION_TRANSITION)),
        ]),
        /** Animation that controls the arrow opacity. */
        arrowOpacity: animations.trigger('arrowOpacity', [
            animations.state('desc-to-active, asc-to-active, active', animations.style({ opacity: 1 })),
            animations.state('desc-to-hint, asc-to-hint, hint', animations.style({ opacity: 0.54 })),
            animations.state('hint-to-desc, active-to-desc, desc, hint-to-asc, active-to-asc, asc, void', animations.style({ opacity: 0 })),
            // Transition between all states except for immediate transitions
            animations.transition('* => asc, * => desc, * => active, * => hint, * => void', animations.animate('0ms')),
            animations.transition('* <=> *', animations.animate(SORT_ANIMATION_TRANSITION)),
        ]),
        /**
         * Animation for the translation of the arrow as a whole. States are separated into two
         * groups: ones with animations and others that are immediate. Immediate states are asc, desc,
         * peek, and active. The other states define a specific animation (source-to-destination)
         * and are determined as a function of their prev user-perceived state and what the next state
         * should be.
         */
        arrowPosition: animations.trigger('arrowPosition', [
            // Hidden Above => Hint Center
            animations.transition('* => desc-to-hint, * => desc-to-active', animations.animate(SORT_ANIMATION_TRANSITION, animations.keyframes([animations.style({ transform: 'translateY(-25%)' }), animations.style({ transform: 'translateY(0)' })]))),
            // Hint Center => Hidden Below
            animations.transition('* => hint-to-desc, * => active-to-desc', animations.animate(SORT_ANIMATION_TRANSITION, animations.keyframes([animations.style({ transform: 'translateY(0)' }), animations.style({ transform: 'translateY(25%)' })]))),
            // Hidden Below => Hint Center
            animations.transition('* => asc-to-hint, * => asc-to-active', animations.animate(SORT_ANIMATION_TRANSITION, animations.keyframes([animations.style({ transform: 'translateY(25%)' }), animations.style({ transform: 'translateY(0)' })]))),
            // Hint Center => Hidden Above
            animations.transition('* => hint-to-asc, * => active-to-asc', animations.animate(SORT_ANIMATION_TRANSITION, animations.keyframes([animations.style({ transform: 'translateY(0)' }), animations.style({ transform: 'translateY(-25%)' })]))),
            animations.state('desc-to-hint, asc-to-hint, hint, desc-to-active, asc-to-active, active', animations.style({ transform: 'translateY(0)' })),
            animations.state('hint-to-desc, active-to-desc, desc', animations.style({ transform: 'translateY(-25%)' })),
            animations.state('hint-to-asc, active-to-asc, asc', animations.style({ transform: 'translateY(25%)' })),
        ]),
        /** Necessary trigger that calls animate on children animations. */
        allowChildren: animations.trigger('allowChildren', [
            animations.transition('* <=> *', [animations.query('@*', animations.animateChild(), { optional: true })]),
        ]),
    };

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * To modify the labels and text displayed, create a new instance of MatSortHeaderIntl and
     * include it in a custom provider.
     */
    var NgbSortHeaderIntl = /** @class */ (function () {
        function NgbSortHeaderIntl() {
            /**
             * Stream that emits whenever the labels here are changed. Use this to notify
             * components if the labels have changed after initialization.
             */
            this.changes = new rxjs.Subject();
        }
        return NgbSortHeaderIntl;
    }());
    NgbSortHeaderIntl.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSortHeaderIntl, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    NgbSortHeaderIntl.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSortHeaderIntl, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSortHeaderIntl, decorators: [{
                type: i0.Injectable,
                args: [{ providedIn: 'root' }]
            }] });
    /** @docs-private */
    function NG_SORT_HEADER_INTL_PROVIDER_FACTORY(parentIntl) {
        return parentIntl || new NgbSortHeaderIntl();
    }
    /** @docs-private */
    var NGB_SORT_HEADER_INTL_PROVIDER = {
        // If there is already an MatSortHeaderIntl available, use that. Otherwise, provide a new one.
        provide: NgbSortHeaderIntl,
        deps: [[new i0.Optional(), new i0.SkipSelf(), NgbSortHeaderIntl]],
        useFactory: NG_SORT_HEADER_INTL_PROVIDER_FACTORY,
    };

    // Boilerplate for applying mixins to the sort header.
    /** @docs-private */
    var _NgbSortHeaderBase = mixinDisabled(/** @class */ (function () {
        function class_1() {
        }
        return class_1;
    }()));
    /**
     * Applies sorting behavior (click to change sort) and styles to an element, including an
     * arrow to display the current sort direction.
     *
     * Must be provided with an id and contained within a parent MatSort directive.
     *
     * If used on header cells in a CdkTable, it will automatically default its id from its containing
     * column definition.
     */
    var NgbSortHeader = /** @class */ (function (_super) {
        __extends(NgbSortHeader, _super);
        function NgbSortHeader(
        /**
         * @deprecated `_intl` parameter isn't being used anymore and it'll be removed.
         * @breaking-change 13.0.0
         */
        _intl, _changeDetectorRef, 
        // `MatSort` is not optionally injected, but just asserted manually w/ better error.
        // tslint:disable-next-line: lightweight-tokens
        _sort, _columnDef, _focusMonitor, _elementRef, 
        /** @breaking-change 14.0.0 _ariaDescriber will be required. */
        _ariaDescriber) {
            var _this = 
            // Note that we use a string token for the `_columnDef`, because the value is provided both by
            // `material/table` and `cdk/table` and we can't have the CDK depending on Material,
            // and we want to avoid having the sort header depending on the CDK table because
            // of this single reference.
            _super.call(this) || this;
            _this._intl = _intl;
            _this._changeDetectorRef = _changeDetectorRef;
            _this._sort = _sort;
            _this._columnDef = _columnDef;
            _this._focusMonitor = _focusMonitor;
            _this._elementRef = _elementRef;
            _this._ariaDescriber = _ariaDescriber;
            /**
             * Flag set to true when the indicator should be displayed while the sort is not active. Used to
             * provide an affordance that the header is sortable by showing on focus and hover.
             */
            _this._showIndicatorHint = false;
            /**
             * The view transition state of the arrow (translation/ opacity) - indicates its `from` and `to`
             * position through the animation. If animations are currently disabled, the fromState is removed
             * so that there is no animation displayed.
             */
            _this._viewState = {};
            /** The direction the arrow should be facing according to the current state. */
            _this._arrowDirection = '';
            /**
             * Whether the view state animation should show the transition between the `from` and `to` states.
             */
            _this._disableViewStateAnimation = false;
            /** Sets the position of the arrow that displays when sorted. */
            _this.arrowPosition = 'after';
            // Default the action description to "Sort" because it's better than nothing.
            // Without a description, the button's label comes from the sort header text content,
            // which doesn't give any indication that it performs a sorting operation.
            _this._sortActionDescription = 'Sort';
            if (!_this.id && _this._columnDef) {
                _this.id = _this._columnDef.name;
            }
            _this._handleStateChanges();
            return _this;
        }
        Object.defineProperty(NgbSortHeader.prototype, "sortActionDescription", {
            /**
             * Description applied to MatSortHeader's button element with aria-describedby. This text should
             * describe the action that will occur when the user clicks the sort header.
             */
            get: function () {
                return this._sortActionDescription;
            },
            set: function (value) {
                this._updateSortActionDescription(value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NgbSortHeader.prototype, "disableClear", {
            /** Overrides the disable clear value of the containing MatSort for this MatSortable. */
            get: function () {
                return this._disableClear;
            },
            set: function (v) {
                this._disableClear = coercion.coerceBooleanProperty(v);
            },
            enumerable: false,
            configurable: true
        });
        NgbSortHeader.prototype.ngOnInit = function () {
            // Initialize the direction of the arrow and set the view state to be immediately that state.
            this._updateArrowDirection();
            this._setAnimationTransitionState({
                toState: this._isSorted() ? 'active' : this._arrowDirection,
            });
            this._sort.register(this);
            this._sortButton = this._elementRef.nativeElement.querySelector('[role="button"]');
            this._updateSortActionDescription(this._sortActionDescription);
        };
        NgbSortHeader.prototype.ngAfterViewInit = function () {
            var _this = this;
            // We use the focus monitor because we also want to style
            // things differently based on the focus origin.
            this._focusMonitor.monitor(this._elementRef, true).subscribe(function (origin) {
                var newState = !!origin;
                if (newState !== _this._showIndicatorHint) {
                    _this._setIndicatorHintVisible(newState);
                    _this._changeDetectorRef.markForCheck();
                }
            });
        };
        NgbSortHeader.prototype.ngOnDestroy = function () {
            this._focusMonitor.stopMonitoring(this._elementRef);
            this._sort.deregister(this);
            this._rerenderSubscription.unsubscribe();
        };
        /**
         * Sets the "hint" state such that the arrow will be semi-transparently displayed as a hint to the
         * user showing what the active sort will become. If set to false, the arrow will fade away.
         */
        NgbSortHeader.prototype._setIndicatorHintVisible = function (visible) {
            // No-op if the sort header is disabled - should not make the hint visible.
            if (this._isDisabled() && visible) {
                return;
            }
            this._showIndicatorHint = visible;
            if (!this._isSorted()) {
                this._updateArrowDirection();
                if (this._showIndicatorHint) {
                    this._setAnimationTransitionState({ fromState: this._arrowDirection, toState: 'hint' });
                }
                else {
                    this._setAnimationTransitionState({ fromState: 'hint', toState: this._arrowDirection });
                }
            }
        };
        /**
         * Sets the animation transition view state for the arrow's position and opacity. If the
         * `disableViewStateAnimation` flag is set to true, the `fromState` will be ignored so that
         * no animation appears.
         */
        NgbSortHeader.prototype._setAnimationTransitionState = function (viewState) {
            this._viewState = viewState || {};
            // If the animation for arrow position state (opacity/translation) should be disabled,
            // remove the fromState so that it jumps right to the toState.
            if (this._disableViewStateAnimation) {
                this._viewState = { toState: viewState.toState };
            }
        };
        /** Triggers the sort on this sort header and removes the indicator hint. */
        NgbSortHeader.prototype._toggleOnInteraction = function () {
            this._sort.sort(this);
            // Do not show the animation if the header was already shown in the right position.
            if (this._viewState.toState === 'hint' || this._viewState.toState === 'active') {
                this._disableViewStateAnimation = true;
            }
        };
        NgbSortHeader.prototype._handleClick = function () {
            if (!this._isDisabled()) {
                this._sort.sort(this);
            }
        };
        NgbSortHeader.prototype._handleKeydown = function (event) {
            if (!this._isDisabled() && (event.keyCode === keycodes.SPACE || event.keyCode === keycodes.ENTER)) {
                event.preventDefault();
                this._toggleOnInteraction();
            }
        };
        /** Whether this MatSortHeader is currently sorted in either ascending or descending order. */
        NgbSortHeader.prototype._isSorted = function () {
            return (this._sort.active == this.id &&
                (this._sort.direction === 'asc' || this._sort.direction === 'desc'));
        };
        /** Returns the animation state for the arrow direction (indicator and pointers). */
        NgbSortHeader.prototype._getArrowDirectionState = function () {
            return "" + (this._isSorted() ? 'active-' : '') + this._arrowDirection;
        };
        /** Returns the arrow position state (opacity, translation). */
        NgbSortHeader.prototype._getArrowViewState = function () {
            var fromState = this._viewState.fromState;
            return (fromState ? fromState + "-to-" : '') + this._viewState.toState;
        };
        /**
         * Updates the direction the arrow should be pointing. If it is not sorted, the arrow should be
         * facing the start direction. Otherwise if it is sorted, the arrow should point in the currently
         * active sorted direction. The reason this is updated through a function is because the direction
         * should only be changed at specific times - when deactivated but the hint is displayed and when
         * the sort is active and the direction changes. Otherwise the arrow's direction should linger
         * in cases such as the sort becoming deactivated but we want to animate the arrow away while
         * preserving its direction, even though the next sort direction is actually different and should
         * only be changed once the arrow displays again (hint or activation).
         */
        NgbSortHeader.prototype._updateArrowDirection = function () {
            this._arrowDirection = this._isSorted() ? this._sort.direction : this.start || this._sort.start;
        };
        NgbSortHeader.prototype._isDisabled = function () {
            return this._sort.disabled || this.disabled;
        };
        /**
         * Gets the aria-sort attribute that should be applied to this sort header. If this header
         * is not sorted, returns null so that the attribute is removed from the host element. Aria spec
         * says that the aria-sort property should only be present on one header at a time, so removing
         * ensures this is true.
         */
        NgbSortHeader.prototype._getAriaSortAttribute = function () {
            if (!this._isSorted()) {
                return 'none';
            }
            return this._sort.direction == 'asc' ? 'ascending' : 'descending';
        };
        /** Whether the arrow inside the sort header should be rendered. */
        NgbSortHeader.prototype._renderArrow = function () {
            return !this._isDisabled() || this._isSorted();
        };
        NgbSortHeader.prototype._updateSortActionDescription = function (newDescription) {
            // We use AriaDescriber for the sort button instead of setting an `aria-label` because some
            // screen readers (notably VoiceOver) will read both the column header *and* the button's label
            // for every *cell* in the table, creating a lot of unnecessary noise.
            var _a, _b;
            // If _sortButton is undefined, the component hasn't been initialized yet so there's
            // nothing to update in the DOM.
            if (this._sortButton) {
                // removeDescription will no-op if there is no existing message.
                // TODO(jelbourn): remove optional chaining when AriaDescriber is required.
                (_a = this._ariaDescriber) === null || _a === void 0 ? void 0 : _a.removeDescription(this._sortButton, this._sortActionDescription);
                (_b = this._ariaDescriber) === null || _b === void 0 ? void 0 : _b.describe(this._sortButton, newDescription);
            }
            this._sortActionDescription = newDescription;
        };
        /** Handles changes in the sorting state. */
        NgbSortHeader.prototype._handleStateChanges = function () {
            var _this = this;
            this._rerenderSubscription = rxjs.merge(this._sort.sortChange, this._sort._stateChanges, this._intl.changes).subscribe(function () {
                if (_this._isSorted()) {
                    _this._updateArrowDirection();
                    // Do not show the animation if the header was already shown in the right position.
                    if (_this._viewState.toState === 'hint' || _this._viewState.toState === 'active') {
                        _this._disableViewStateAnimation = true;
                    }
                    _this._setAnimationTransitionState({ fromState: _this._arrowDirection, toState: 'active' });
                    _this._showIndicatorHint = false;
                }
                // If this header was recently active and now no longer sorted, animate away the arrow.
                if (!_this._isSorted() && _this._viewState && _this._viewState.toState === 'active') {
                    _this._disableViewStateAnimation = false;
                    _this._setAnimationTransitionState({ fromState: 'active', toState: _this._arrowDirection });
                }
                _this._changeDetectorRef.markForCheck();
            });
        };
        return NgbSortHeader;
    }(_NgbSortHeaderBase));
    NgbSortHeader.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSortHeader, deps: [{ token: NgbSortHeaderIntl }, { token: i0__namespace.ChangeDetectorRef }, { token: NgbSort, optional: true }, { token: 'NGB_SORT_HEADER_COLUMN_DEF', optional: true }, { token: i3__namespace.FocusMonitor }, { token: i0__namespace.ElementRef }, { token: i3__namespace.AriaDescriber, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Component });
    NgbSortHeader.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: NgbSortHeader, selector: "[ngb-sort-header]", inputs: { disabled: "disabled", id: ["mat-sort-header", "id"], arrowPosition: "arrowPosition", start: "start", sortActionDescription: "sortActionDescription", disableClear: "disableClear" }, host: { listeners: { "click": "_handleClick()", "keydown": "_handleKeydown($event)", "mouseenter": "_setIndicatorHintVisible(true)", "mouseleave": "_setIndicatorHintVisible(false)" }, properties: { "attr.aria-sort": "_getAriaSortAttribute()", "class.ngb-sort-header-disabled": "_isDisabled()" }, classAttribute: "ngb-sort-header" }, exportAs: ["ngbSortHeader"], usesInheritance: true, ngImport: i0__namespace, template: "<!--\n  We set the `tabindex` on an element inside the table header, rather than the header itself,\n  because of a bug in NVDA where having a `tabindex` on a `th` breaks keyboard navigation in the\n  table (see https://github.com/nvaccess/nvda/issues/7718). This allows for the header to both\n  be focusable, and have screen readers read out its `aria-sort` state. We prefer this approach\n  over having a button with an `aria-label` inside the header, because the button's `aria-label`\n  will be read out as the user is navigating the table's cell (see #13012).\n  The approach is based off of: https://dequeuniversity.com/library/aria/tables/sf-sortable-grid\n-->\n<div class=\"ngb-sort-header-container\"\n     [class.mat-sort-header-sorted]=\"_isSorted()\"\n     [class.mat-sort-header-position-before]=\"arrowPosition == 'before'\"\n     [attr.tabindex]=\"_isDisabled() ? null : 0\"\n     role=\"button\">\n\n  <!--\n    TODO(crisbeto): this div isn't strictly necessary, but we have to keep it due to a large\n    number of screenshot diff failures. It should be removed eventually. Note that the difference\n    isn't visible with a shorter header, but once it breaks up into multiple lines, this element\n    causes it to be center-aligned, whereas removing it will keep the text to the left.\n  -->\n  <div class=\"ngb-sort-header-content\">\n    <ng-content></ng-content>\n  </div>\n\n  <!-- Disable animations while a current animation is running -->\n  <div class=\"ngb-sort-header-arrow\"\n       *ngIf=\"_renderArrow()\"\n       [@arrowOpacity]=\"_getArrowViewState()\"\n       [@arrowPosition]=\"_getArrowViewState()\"\n       [@allowChildren]=\"_getArrowDirectionState()\"\n       (@arrowPosition.start)=\"_disableViewStateAnimation = true\"\n       (@arrowPosition.done)=\"_disableViewStateAnimation = false\">\n    <div class=\"ngb-sort-header-stem\"></div>\n    <div class=\"ngb-sort-header-indicator\" [@indicator]=\"_getArrowDirectionState()\">\n      <div class=\"ngb-sort-header-pointer-left\" [@leftPointer]=\"_getArrowDirectionState()\"></div>\n      <div class=\"ngb-sort-header-pointer-right\" [@rightPointer]=\"_getArrowDirectionState()\"></div>\n      <div class=\"ngb-sort-header-pointer-middle\"></div>\n    </div>\n  </div>\n</div>\n", styles: [".ngb-sort-header-container{display:flex;cursor:pointer;align-items:center;letter-spacing:normal;outline:0}[ngb-sort-header].cdk-keyboard-focused .ngb-sort-header-container,[ngb-sort-header].cdk-program-focused .ngb-sort-header-container{border-bottom:solid 1px currentColor}.ngb-sort-header-disabled .ngb-sort-header-container{cursor:default}.ngb-sort-header-content{text-align:center;display:flex;align-items:center}.ngb-sort-header-position-before{flex-direction:row-reverse}.ngb-sort-header-arrow{height:12px;width:12px;min-width:12px;position:relative;display:flex;opacity:0}.ngb-sort-header-arrow,[dir=rtl] .ngb-sort-header-position-before .ngb-sort-header-arrow{margin:0 0 0 6px}.ngb-sort-header-position-before .ngb-sort-header-arrow,[dir=rtl] .ngb-sort-header-arrow{margin:0 6px 0 0}.ngb-sort-header-stem{background:currentColor;height:10px;width:2px;margin:auto;display:flex;align-items:center}.cdk-high-contrast-active .ngb-sort-header-stem{width:0;border-left:solid 2px}.ngb-sort-header-indicator{width:100%;height:2px;display:flex;align-items:center;position:absolute;top:0;left:0}.ngb-sort-header-pointer-middle{margin:auto;height:2px;width:2px;background:currentColor;transform:rotate(45deg)}.cdk-high-contrast-active .ngb-sort-header-pointer-middle{width:0;height:0;border-top:solid 2px;border-left:solid 2px}.ngb-sort-header-pointer-left,.ngb-sort-header-pointer-right{background:currentColor;width:6px;height:2px;position:absolute;top:0}.cdk-high-contrast-active .ngb-sort-header-pointer-left,.cdk-high-contrast-active .ngb-sort-header-pointer-right{width:0;height:0;border-left:solid 6px;border-top:solid 2px}.ngb-sort-header-pointer-left{transform-origin:right;left:0}.ngb-sort-header-pointer-right{transform-origin:left;right:0}\n"], directives: [{ type: i4__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [
            ngbSortAnimations.indicator,
            ngbSortAnimations.leftPointer,
            ngbSortAnimations.rightPointer,
            ngbSortAnimations.arrowOpacity,
            ngbSortAnimations.arrowPosition,
            ngbSortAnimations.allowChildren,
        ], changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSortHeader, decorators: [{
                type: i0.Component,
                args: [{
                        selector: '[ngb-sort-header]',
                        exportAs: 'ngbSortHeader',
                        templateUrl: 'sort-header.html',
                        styleUrls: ['sort-header.scss'],
                        host: {
                            'class': 'ngb-sort-header',
                            '(click)': '_handleClick()',
                            '(keydown)': '_handleKeydown($event)',
                            '(mouseenter)': '_setIndicatorHintVisible(true)',
                            '(mouseleave)': '_setIndicatorHintVisible(false)',
                            '[attr.aria-sort]': '_getAriaSortAttribute()',
                            '[class.ngb-sort-header-disabled]': '_isDisabled()',
                        },
                        encapsulation: i0.ViewEncapsulation.None,
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        inputs: ['disabled'],
                        animations: [
                            ngbSortAnimations.indicator,
                            ngbSortAnimations.leftPointer,
                            ngbSortAnimations.rightPointer,
                            ngbSortAnimations.arrowOpacity,
                            ngbSortAnimations.arrowPosition,
                            ngbSortAnimations.allowChildren,
                        ],
                    }]
            }], ctorParameters: function () {
            return [{ type: NgbSortHeaderIntl }, { type: i0__namespace.ChangeDetectorRef }, { type: NgbSort, decorators: [{
                            type: i0.Optional
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: ['NGB_SORT_HEADER_COLUMN_DEF']
                        }, {
                            type: i0.Optional
                        }] }, { type: i3__namespace.FocusMonitor }, { type: i0__namespace.ElementRef }, { type: i3__namespace.AriaDescriber, decorators: [{
                            type: i0.Optional
                        }] }];
        }, propDecorators: { id: [{
                    type: i0.Input,
                    args: ['mat-sort-header']
                }], arrowPosition: [{
                    type: i0.Input
                }], start: [{
                    type: i0.Input
                }], sortActionDescription: [{
                    type: i0.Input
                }], disableClear: [{
                    type: i0.Input
                }] } });

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    var NgbSortModule = /** @class */ (function () {
        function NgbSortModule() {
        }
        return NgbSortModule;
    }());
    NgbSortModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSortModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    NgbSortModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSortModule, declarations: [NgbSort, NgbSortHeader], imports: [i4.CommonModule], exports: [NgbSort, NgbSortHeader] });
    NgbSortModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSortModule, providers: [NGB_SORT_HEADER_INTL_PROVIDER], imports: [[i4.CommonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbSortModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        imports: [i4.CommonModule],
                        exports: [NgbSort, NgbSortHeader],
                        declarations: [NgbSort, NgbSortHeader],
                        providers: [NGB_SORT_HEADER_INTL_PROVIDER],
                    }]
            }] });

    /**
     * Cell definition for the mat-table.
     * Captures the template of a column's data row cell as well as cell-specific properties.
     */
    var NgbCellDef = /** @class */ (function (_super) {
        __extends(NgbCellDef, _super);
        function NgbCellDef() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbCellDef;
    }(i1.CdkCellDef));
    NgbCellDef.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbCellDef, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbCellDef.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbCellDef, selector: "[ngbCellDef]", providers: [{ provide: i1.CdkCellDef, useExisting: NgbCellDef }], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbCellDef, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngbCellDef]',
                        providers: [{ provide: i1.CdkCellDef, useExisting: NgbCellDef }],
                    }]
            }] });
    /**
     * Header cell definition for the mat-table.
     * Captures the template of a column's header cell and as well as cell-specific properties.
     */
    var NgbHeaderCellDef = /** @class */ (function (_super) {
        __extends(NgbHeaderCellDef, _super);
        function NgbHeaderCellDef() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbHeaderCellDef;
    }(i1.CdkHeaderCellDef));
    NgbHeaderCellDef.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbHeaderCellDef, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbHeaderCellDef.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbHeaderCellDef, selector: "[ngbHeaderCellDef]", providers: [{ provide: i1.CdkHeaderCellDef, useExisting: NgbHeaderCellDef }], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbHeaderCellDef, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngbHeaderCellDef]',
                        providers: [{ provide: i1.CdkHeaderCellDef, useExisting: NgbHeaderCellDef }],
                    }]
            }] });
    /**
     * Footer cell definition for the mat-table.
     * Captures the template of a column's footer cell and as well as cell-specific properties.
     */
    var NgbFooterCellDef = /** @class */ (function (_super) {
        __extends(NgbFooterCellDef, _super);
        function NgbFooterCellDef() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbFooterCellDef;
    }(i1.CdkFooterCellDef));
    NgbFooterCellDef.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbFooterCellDef, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbFooterCellDef.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbFooterCellDef, selector: "[ngbFooterCellDef]", providers: [{ provide: i1.CdkFooterCellDef, useExisting: NgbFooterCellDef }], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbFooterCellDef, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngbFooterCellDef]',
                        providers: [{ provide: i1.CdkFooterCellDef, useExisting: NgbFooterCellDef }],
                    }]
            }] });
    /**
     * Column definition for the mat-table.
     * Defines a set of cells available for a table column.
     */
    var NgbColumnDef = /** @class */ (function (_super) {
        __extends(NgbColumnDef, _super);
        function NgbColumnDef() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(NgbColumnDef.prototype, "name", {
            /** Unique name for this column. */
            get: function () {
                return this._name;
            },
            set: function (name) {
                this._setNameInput(name);
            },
            enumerable: false,
            configurable: true
        });
        return NgbColumnDef;
    }(i1.CdkColumnDef));
    NgbColumnDef.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbColumnDef, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbColumnDef.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbColumnDef, selector: "[ngbColumnDef]", inputs: { name: ["ngbColumnDef", "name"] }, providers: [
            { provide: i1.CdkColumnDef, useExisting: NgbColumnDef },
            { provide: 'NGB_SORT_HEADER_COLUMN_DEF', useExisting: NgbColumnDef },
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbColumnDef, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngbColumnDef]',
                        providers: [
                            { provide: i1.CdkColumnDef, useExisting: NgbColumnDef },
                            { provide: 'NGB_SORT_HEADER_COLUMN_DEF', useExisting: NgbColumnDef },
                        ],
                    }]
            }], propDecorators: { name: [{
                    type: i0.Input,
                    args: ['ngbColumnDef']
                }] } });
    /** Header cell template container that adds the right classes and role. */
    var NgbHeaderCell = /** @class */ (function (_super) {
        __extends(NgbHeaderCell, _super);
        function NgbHeaderCell() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbHeaderCell;
    }(i1.CdkHeaderCell));
    NgbHeaderCell.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbHeaderCell, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbHeaderCell.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbHeaderCell, selector: "ngb-header-cell, th[ngb-header-cell]", usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbHeaderCell, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: 'ngb-header-cell, th[ngb-header-cell]',
                    }]
            }] });
    /** Footer cell template container that adds the right classes and role. */
    var NgbFooterCell = /** @class */ (function (_super) {
        __extends(NgbFooterCell, _super);
        function NgbFooterCell() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbFooterCell;
    }(i1.CdkFooterCell));
    NgbFooterCell.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbFooterCell, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbFooterCell.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbFooterCell, selector: "ngb-footer-cell, td[ngb-footer-cell]", usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbFooterCell, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: 'ngb-footer-cell, td[ngb-footer-cell]',
                    }]
            }] });
    /** Cell template container that adds the right classes and role. */
    var NgbCell = /** @class */ (function (_super) {
        __extends(NgbCell, _super);
        function NgbCell() {
            var _this = _super.apply(this, __spreadArray([], __read(arguments))) || this;
            _this.whiteSpace = 'nowrap';
            return _this;
        }
        return NgbCell;
    }(i1.CdkCell));
    NgbCell.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbCell, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbCell.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbCell, selector: "ngb-cell, td[ngb-cell]", inputs: { whiteSpace: "whiteSpace" }, host: { properties: { "style.white-space": "this.whiteSpace" } }, usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbCell, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: 'ngb-cell, td[ngb-cell]',
                    }]
            }], propDecorators: { whiteSpace: [{
                    type: i0.HostBinding,
                    args: ['style.white-space']
                }, {
                    type: i0.Input
                }] } });

    /**
     * Corresponds to `Number.MAX_SAFE_INTEGER`. Moved out into a variable here due to
     * flaky browser support and the value not being defined in Closure's typings.
     */
    var MAX_SAFE_INTEGER = 9007199254740991;
    /** Shared base class with MDC-based implementation. */
    var _NgbTableDataSource = /** @class */ (function (_super) {
        __extends(_NgbTableDataSource, _super);
        function _NgbTableDataSource(initialData) {
            if (initialData === void 0) { initialData = []; }
            var _this = _super.call(this) || this;
            /** Stream emitting render data to the table (depends on ordered data changes). */
            _this._renderData = new rxjs.BehaviorSubject([]);
            /** Stream that emits when a new filter string is set on the data source. */
            _this._filter = new rxjs.BehaviorSubject('');
            /** Used to react to internal changes of the paginator that are made by the data source itself. */
            _this._internalPageChanges = new rxjs.Subject();
            /**
             * Subscription to the changes that should trigger an update to the table's rendered rows, such
             * as filtering, sorting, pagination, or base data changes.
             */
            _this._renderChangesSubscription = null;
            /**
             * Data accessor function that is used for accessing data properties for sorting through
             * the default sortData function.
             * This default function assumes that the sort header IDs (which defaults to the column name)
             * matches the data's properties (e.g. column Xyz represents data['Xyz']).
             * May be set to a custom function for different behavior.
             * @param data Data object that is being accessed.
             * @param sortHeaderId The name of the column that represents the data.
             */
            _this.sortingDataAccessor = function (data, sortHeaderId) {
                var value = data[sortHeaderId];
                if (coercion._isNumberValue(value)) {
                    var numberValue = Number(value);
                    // Numbers beyond `MAX_SAFE_INTEGER` can't be compared reliably so we
                    // leave them as strings. For more info: https://goo.gl/y5vbSg
                    return numberValue < MAX_SAFE_INTEGER ? numberValue : value;
                }
                return value;
            };
            /**
             * Gets a sorted copy of the data array based on the state of the MatSort. Called
             * after changes are made to the filtered data or when sort changes are emitted from MatSort.
             * By default, the function retrieves the active sort and its direction and compares data
             * by retrieving data using the sortingDataAccessor. May be overridden for a custom implementation
             * of data ordering.
             * @param data The array of data that should be sorted.
             * @param sort The connected MatSort that holds the current sort state.
             */
            _this.sortData = function (data, sort) {
                var active = sort.active;
                var direction = sort.direction;
                if (!active || direction == '') {
                    return data;
                }
                return data.sort(function (a, b) {
                    var valueA = _this.sortingDataAccessor(a, active);
                    var valueB = _this.sortingDataAccessor(b, active);
                    // If there are data in the column that can be converted to a number,
                    // it must be ensured that the rest of the data
                    // is of the same type so as not to order incorrectly.
                    var valueAType = typeof valueA;
                    var valueBType = typeof valueB;
                    if (valueAType !== valueBType) {
                        if (valueAType === 'number') {
                            valueA += '';
                        }
                        if (valueBType === 'number') {
                            valueB += '';
                        }
                    }
                    // If both valueA and valueB exist (truthy), then compare the two. Otherwise, check if
                    // one value exists while the other doesn't. In this case, existing value should come last.
                    // This avoids inconsistent results when comparing values to undefined/null.
                    // If neither value exists, return 0 (equal).
                    var comparatorResult = 0;
                    if (valueA != null && valueB != null) {
                        // Check if one value is greater than the other; if equal, comparatorResult should remain 0.
                        if (valueA > valueB) {
                            comparatorResult = 1;
                        }
                        else if (valueA < valueB) {
                            comparatorResult = -1;
                        }
                    }
                    else if (valueA != null) {
                        comparatorResult = 1;
                    }
                    else if (valueB != null) {
                        comparatorResult = -1;
                    }
                    return comparatorResult * (direction == 'asc' ? 1 : -1);
                });
            };
            /**
             * Checks if a data object matches the data source's filter string. By default, each data object
             * is converted to a string of its properties and returns true if the filter has
             * at least one occurrence in that string. By default, the filter string has its whitespace
             * trimmed and the match is case-insensitive. May be overridden for a custom implementation of
             * filter matching.
             * @param data Data object used to check against the filter.
             * @param filter Filter string that has been set on the data source.
             * @returns Whether the filter matches against the data
             */
            _this.filterPredicate = function (data, filter) {
                // Transform the data into a lowercase string of all property values.
                var dataStr = Object.keys(data)
                    .reduce(function (currentTerm, key) {
                    // Use an obscure Unicode character to delimit the words in the concatenated string.
                    // This avoids matches where the values of two columns combined will match the user's query
                    // (e.g. `Flute` and `Stop` will match `Test`). The character is intended to be something
                    // that has a very low chance of being typed in by somebody in a text field. This one in
                    // particular is "White up-pointing triangle with dot" from
                    // https://en.wikipedia.org/wiki/List_of_Unicode_characters
                    return currentTerm + data[key] + '◬';
                }, '')
                    .toLowerCase();
                // Transform the filter by converting it to lowercase and removing whitespace.
                var transformedFilter = filter.trim().toLowerCase();
                return dataStr.indexOf(transformedFilter) != -1;
            };
            _this._data = new rxjs.BehaviorSubject(initialData);
            _this._updateChangeSubscription();
            return _this;
        }
        Object.defineProperty(_NgbTableDataSource.prototype, "data", {
            /** Array of data that should be rendered by the table, where each object represents one row. */
            get: function () {
                return this._data.value;
            },
            set: function (data) {
                this._data.next(data);
                // Normally the `filteredData` is updated by the re-render
                // subscription, but that won't happen if it's inactive.
                if (!this._renderChangesSubscription) {
                    this._filterData(data);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(_NgbTableDataSource.prototype, "filter", {
            /**
             * Filter term that should be used to filter out objects from the data array. To override how
             * data objects match to this filter string, provide a custom function for filterPredicate.
             */
            get: function () {
                return this._filter.value;
            },
            // /**
            //  * Instance of the MatPaginator component used by the table to control what page of the data is
            //  * displayed. Page changes emitted by the MatPaginator will trigger an update to the
            //  * table's rendered data.
            //  *
            //  * Note that the data source uses the paginator's properties to calculate which page of data
            //  * should be displayed. If the paginator receives its properties as template inputs,
            //  * e.g. `[pageLength]=100` or `[pageIndex]=1`, then be sure that the paginator's view has been
            //  * initialized before assigning it to this data source.
            //  */
            // get paginator(): P | null {
            //   return this._paginator;
            // }
            // set paginator(paginator: P | null) {
            //   this._paginator = paginator;
            //   this._updateChangeSubscription();
            // }
            // private _paginator: P | null;
            set: function (filter) {
                this._filter.next(filter);
                // Normally the `filteredData` is updated by the re-render
                // subscription, but that won't happen if it's inactive.
                if (!this._renderChangesSubscription) {
                    this._filterData(this.data);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(_NgbTableDataSource.prototype, "sort", {
            /**
             * Instance of the MatSort directive used by the table to control its sorting. Sort changes
             * emitted by the MatSort will trigger an update to the table's rendered data.
             */
            get: function () {
                return this._sort;
            },
            set: function (sort) {
                this._sort = sort;
                this._updateChangeSubscription();
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Subscribe to changes that should trigger an update to the table's rendered rows. When the
         * changes occur, process the current state of the filter, sort, and pagination along with
         * the provided base data and send it to the table for rendering.
         */
        _NgbTableDataSource.prototype._updateChangeSubscription = function () {
            var _this = this;
            var _a;
            // Sorting and/or pagination should be watched if MatSort and/or MatPaginator are provided.
            // The events should emit whenever the component emits a change or initializes, or if no
            // component is provided, a stream with just a null event should be provided.
            // The `sortChange` and `pageChange` acts as a signal to the combineLatests below so that the
            // pipeline can progress to the next step. Note that the value from these streams are not used,
            // they purely act as a signal to progress in the pipeline.
            var sortChange = this._sort
                ? rxjs.merge(this._sort.sortChange, this._sort.initialized)
                : rxjs.of(null);
            var dataStream = this._data;
            // Watch for base data or filter changes to provide a filtered set of data.
            var filteredData = rxjs.combineLatest([dataStream, this._filter]).pipe(operators.map(function (_b) {
                var _c = __read(_b, 1), data = _c[0];
                return _this._filterData(data);
            }));
            // Watch for filtered data or sort changes to provide an ordered set of data.
            var orderedData = rxjs.combineLatest([filteredData, sortChange]).pipe(operators.map(function (_b) {
                var _c = __read(_b, 1), data = _c[0];
                return _this._orderData(data);
            }));
            // Watched for paged data changes and send the result to the table to render.
            (_a = this._renderChangesSubscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
            this._renderChangesSubscription = orderedData.subscribe(function (data) { return _this._renderData.next(data); });
        };
        /**
         * Returns a filtered data array where each filter object contains the filter string within
         * the result of the filterTermAccessor function. If no filter is set, returns the data array
         * as provided.
         */
        _NgbTableDataSource.prototype._filterData = function (data) {
            var _this = this;
            // If there is a filter string, filter out data that does not contain it.
            // Each data object is converted to a string using the function defined by filterTermAccessor.
            // May be overridden for customization.
            this.filteredData = this.filter == null || this.filter === '' ? data : data.filter(function (obj) { return _this.filterPredicate(obj, _this.filter); });
            return this.filteredData;
        };
        /**
         * Returns a sorted copy of the data if MatSort has a sort applied, otherwise just returns the
         * data array as provided. Uses the default data accessor for data lookup, unless a
         * sortDataAccessor function is defined.
         */
        _NgbTableDataSource.prototype._orderData = function (data) {
            // If there is no active sort or direction, return the data without trying to sort.
            if (!this.sort) {
                return data;
            }
            return this.sortData(data.slice(), this.sort);
        };
        /**
         * Used by the MatTable. Called when it connects to the data source.
         * @docs-private
         */
        _NgbTableDataSource.prototype.connect = function () {
            if (!this._renderChangesSubscription) {
                this._updateChangeSubscription();
            }
            return this._renderData;
        };
        /**
         * Used by the MatTable. Called when it disconnects from the data source.
         * @docs-private
         */
        _NgbTableDataSource.prototype.disconnect = function () {
            var _a;
            (_a = this._renderChangesSubscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
            this._renderChangesSubscription = null;
        };
        return _NgbTableDataSource;
    }(i1.DataSource));
    /**
     * Data source that accepts a client-side data array and includes native support of filtering,
     * sorting (using MatSort), and pagination (using MatPaginator).
     *
     * Allows for sort customization by overriding sortingDataAccessor, which defines how data
     * properties are accessed. Also allows for filter customization by overriding filterTermAccessor,
     * which defines how row data is converted to a string for filter matching.
     *
     * **Note:** This class is meant to be a simple data source to help you get started. As such
     * it isn't equipped to handle some more advanced cases like robust i18n support or server-side
     * interactions. If your app needs to support more advanced use cases, consider implementing your
     * own `DataSource`.
     */
    var NgbTableDataSource = /** @class */ (function (_super) {
        __extends(NgbTableDataSource, _super);
        function NgbTableDataSource() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbTableDataSource;
    }(_NgbTableDataSource));

    /**
     * Header row definition for the mat-table.
     * Captures the header row's template and other header properties such as the columns to display.
     */
    var NgbHeaderRowDef = /** @class */ (function (_super) {
        __extends(NgbHeaderRowDef, _super);
        function NgbHeaderRowDef() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbHeaderRowDef;
    }(i1.CdkHeaderRowDef));
    NgbHeaderRowDef.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbHeaderRowDef, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbHeaderRowDef.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbHeaderRowDef, selector: "[ngbHeaderRowDef]", inputs: { columns: ["ngbHeaderRowDef", "columns"] }, providers: [{ provide: i1.CdkHeaderRowDef, useExisting: NgbHeaderRowDef }], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbHeaderRowDef, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngbHeaderRowDef]',
                        providers: [{ provide: i1.CdkHeaderRowDef, useExisting: NgbHeaderRowDef }],
                        inputs: ['columns: ngbHeaderRowDef'],
                    }]
            }] });
    /**
     * Footer row definition for the mat-table.
     * Captures the footer row's template and other footer properties such as the columns to display.
     */
    var NgbFooterRowDef = /** @class */ (function (_super) {
        __extends(NgbFooterRowDef, _super);
        function NgbFooterRowDef() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbFooterRowDef;
    }(i1.CdkFooterRowDef));
    NgbFooterRowDef.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbFooterRowDef, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbFooterRowDef.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbFooterRowDef, selector: "[ngbFooterRowDef]", inputs: { columns: ["ngbFooterRowDef", "columns"] }, providers: [{ provide: i1.CdkFooterRowDef, useExisting: NgbFooterRowDef }], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbFooterRowDef, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngbFooterRowDef]',
                        providers: [{ provide: i1.CdkFooterRowDef, useExisting: NgbFooterRowDef }],
                        inputs: ['columns: ngbFooterRowDef'],
                    }]
            }] });
    /**
     * Data row definition for the mat-table.
     * Captures the data row's template and other properties such as the columns to display and
     * a when predicate that describes when this row should be used.
     */
    var NgbRowDef = /** @class */ (function (_super) {
        __extends(NgbRowDef, _super);
        function NgbRowDef() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbRowDef;
    }(i1.CdkRowDef));
    NgbRowDef.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbRowDef, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbRowDef.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbRowDef, selector: "[ngbRowDef]", inputs: { columns: ["ngbRowDefColumns", "columns"], when: ["ngbRowDefWhen", "when"] }, providers: [{ provide: i1.CdkRowDef, useExisting: NgbRowDef }], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbRowDef, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngbRowDef]',
                        providers: [{ provide: i1.CdkRowDef, useExisting: NgbRowDef }],
                        inputs: ['columns: ngbRowDefColumns', 'when: ngbRowDefWhen'],
                    }]
            }] });
    /** Header template container that contains the cell outlet. Adds the right class and role. */
    var NgbHeaderRow = /** @class */ (function (_super) {
        __extends(NgbHeaderRow, _super);
        function NgbHeaderRow() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbHeaderRow;
    }(i1.CdkHeaderRow));
    NgbHeaderRow.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbHeaderRow, deps: null, target: i0__namespace.ɵɵFactoryTarget.Component });
    NgbHeaderRow.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: NgbHeaderRow, selector: "ngb-header-row, tr[ngb-header-row]", providers: [{ provide: i1.CdkHeaderRow, useExisting: NgbHeaderRow }], exportAs: ["ngbHeaderRow"], usesInheritance: true, ngImport: i0__namespace, template: "<ng-container cdkCellOutlet></ng-container>", isInline: true, directives: [{ type: i1__namespace.CdkCellOutlet, selector: "[cdkCellOutlet]" }], changeDetection: i0__namespace.ChangeDetectionStrategy.Default, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbHeaderRow, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngb-header-row, tr[ngb-header-row]',
                        template: i1.CDK_ROW_TEMPLATE,
                        // See note on CdkTable for explanation on why this uses the default change detection strategy.
                        // tslint:disable-next-line:validate-decorators
                        changeDetection: i0.ChangeDetectionStrategy.Default,
                        encapsulation: i0.ViewEncapsulation.None,
                        exportAs: 'ngbHeaderRow',
                        providers: [{ provide: i1.CdkHeaderRow, useExisting: NgbHeaderRow }],
                    }]
            }] });
    /** Footer template container that contains the cell outlet. Adds the right class and role. */
    var NgbFooterRow = /** @class */ (function (_super) {
        __extends(NgbFooterRow, _super);
        function NgbFooterRow() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbFooterRow;
    }(i1.CdkFooterRow));
    NgbFooterRow.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbFooterRow, deps: null, target: i0__namespace.ɵɵFactoryTarget.Component });
    NgbFooterRow.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: NgbFooterRow, selector: "ngb-footer-row, tr[ngb-footer-row]", providers: [{ provide: i1.CdkFooterRow, useExisting: NgbFooterRow }], exportAs: ["ngbFooterRow"], usesInheritance: true, ngImport: i0__namespace, template: "<ng-container cdkCellOutlet></ng-container>", isInline: true, directives: [{ type: i1__namespace.CdkCellOutlet, selector: "[cdkCellOutlet]" }], changeDetection: i0__namespace.ChangeDetectionStrategy.Default, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbFooterRow, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngb-footer-row, tr[ngb-footer-row]',
                        template: i1.CDK_ROW_TEMPLATE,
                        // See note on CdkTable for explanation on why this uses the default change detection strategy.
                        // tslint:disable-next-line:validate-decorators
                        changeDetection: i0.ChangeDetectionStrategy.Default,
                        encapsulation: i0.ViewEncapsulation.None,
                        exportAs: 'ngbFooterRow',
                        providers: [{ provide: i1.CdkFooterRow, useExisting: NgbFooterRow }],
                    }]
            }] });
    /** Data row template container that contains the cell outlet. Adds the right class and role. */
    var NgbRow = /** @class */ (function (_super) {
        __extends(NgbRow, _super);
        function NgbRow() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbRow;
    }(i1.CdkRow));
    NgbRow.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbRow, deps: null, target: i0__namespace.ɵɵFactoryTarget.Component });
    NgbRow.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: NgbRow, selector: "ngb-row, tr[ngb-row]", providers: [{ provide: i1.CdkRow, useExisting: NgbRow }], exportAs: ["ngbRow"], usesInheritance: true, ngImport: i0__namespace, template: "<ng-container cdkCellOutlet></ng-container>", isInline: true, directives: [{ type: i1__namespace.CdkCellOutlet, selector: "[cdkCellOutlet]" }], changeDetection: i0__namespace.ChangeDetectionStrategy.Default, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbRow, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngb-row, tr[ngb-row]',
                        template: i1.CDK_ROW_TEMPLATE,
                        // See note on CdkTable for explanation on why this uses the default change detection strategy.
                        // tslint:disable-next-line:validate-decorators
                        changeDetection: i0.ChangeDetectionStrategy.Default,
                        encapsulation: i0.ViewEncapsulation.None,
                        exportAs: 'ngbRow',
                        providers: [{ provide: i1.CdkRow, useExisting: NgbRow }],
                    }]
            }] });
    /** Row that can be used to display a message when no data is shown in the table. */
    var NgbNoDataRow = /** @class */ (function (_super) {
        __extends(NgbNoDataRow, _super);
        function NgbNoDataRow() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbNoDataRow;
    }(i1.CdkNoDataRow));
    NgbNoDataRow.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbNoDataRow, deps: null, target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbNoDataRow.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbNoDataRow, selector: "ng-template[ngbNoDataRow]", providers: [{ provide: i1.CdkNoDataRow, useExisting: NgbNoDataRow }], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbNoDataRow, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: 'ng-template[ngbNoDataRow]',
                        providers: [{ provide: i1.CdkNoDataRow, useExisting: NgbNoDataRow }],
                    }]
            }] });

    /**
     * Enables the recycle view repeater strategy, which reduces rendering latency. Not compatible with
     * tables that animate rows.
     */
    var NgbRecycleRows = /** @class */ (function () {
        function NgbRecycleRows() {
        }
        return NgbRecycleRows;
    }());
    NgbRecycleRows.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbRecycleRows, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgbRecycleRows.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: NgbRecycleRows, selector: "ngb-table[recycleRows], table[ngb-table][recycleRows]", providers: [{ provide: collections._VIEW_REPEATER_STRATEGY, useClass: collections._RecycleViewRepeaterStrategy }], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbRecycleRows, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: 'ngb-table[recycleRows], table[ngb-table][recycleRows]',
                        providers: [{ provide: collections._VIEW_REPEATER_STRATEGY, useClass: collections._RecycleViewRepeaterStrategy }],
                    }]
            }] });
    /**
     * Wrapper for the CdkTable with Material design styles.
     */
    var NgbTable = /** @class */ (function (_super) {
        __extends(NgbTable, _super);
        function NgbTable() {
            var _this = _super.apply(this, __spreadArray([], __read(arguments))) || this;
            /** Overrides the need to add position: sticky on every sticky cell element in `CdkTable`. */
            _this.needsPositionStickyOnElement = false;
            _this.cdkTable = true;
            _this.table = true;
            _this.hover = false;
            return _this;
        }
        return NgbTable;
    }(i1.CdkTable));
    NgbTable.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbTable, deps: null, target: i0__namespace.ɵɵFactoryTarget.Component });
    NgbTable.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: NgbTable, selector: "ngb-table, table[ngb-table]", inputs: { hover: "hover" }, host: { properties: { "class.cdk-table": "this.cdkTable", "class.table": "this.table", "class.table-hover": "this.hover" } }, providers: [
            { provide: collections._VIEW_REPEATER_STRATEGY, useClass: collections._DisposeViewRepeaterStrategy },
            { provide: i1.CdkTable, useExisting: NgbTable },
            { provide: i1.CDK_TABLE, useExisting: NgbTable },
            { provide: i1._COALESCED_STYLE_SCHEDULER, useClass: i1._CoalescedStyleScheduler },
            // Prevent nested tables from seeing this table's StickyPositioningListener.
            { provide: i1.STICKY_POSITIONING_LISTENER, useValue: null },
        ], exportAs: ["ngbTable"], usesInheritance: true, ngImport: i0__namespace, template: "\n  <ng-content select=\"caption\"></ng-content>\n  <ng-content select=\"colgroup, col\"></ng-content>\n  <ng-container headerRowOutlet></ng-container>\n  <ng-container rowOutlet></ng-container>\n  <ng-container noDataRowOutlet></ng-container>\n  <ng-container footerRowOutlet></ng-container>\n", isInline: true, directives: [{ type: i1__namespace.HeaderRowOutlet, selector: "[headerRowOutlet]" }, { type: i1__namespace.DataRowOutlet, selector: "[rowOutlet]" }, { type: i1__namespace.NoDataRowOutlet, selector: "[noDataRowOutlet]" }, { type: i1__namespace.FooterRowOutlet, selector: "[footerRowOutlet]" }], changeDetection: i0__namespace.ChangeDetectionStrategy.Default, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbTable, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngb-table, table[ngb-table]',
                        exportAs: 'ngbTable',
                        template: i1.CDK_TABLE_TEMPLATE,
                        providers: [
                            { provide: collections._VIEW_REPEATER_STRATEGY, useClass: collections._DisposeViewRepeaterStrategy },
                            { provide: i1.CdkTable, useExisting: NgbTable },
                            { provide: i1.CDK_TABLE, useExisting: NgbTable },
                            { provide: i1._COALESCED_STYLE_SCHEDULER, useClass: i1._CoalescedStyleScheduler },
                            // Prevent nested tables from seeing this table's StickyPositioningListener.
                            { provide: i1.STICKY_POSITIONING_LISTENER, useValue: null },
                        ],
                        encapsulation: i0.ViewEncapsulation.None,
                        // See note on CdkTable for explanation on why this uses the default change detection strategy.
                        // tslint:disable-next-line:validate-decorators
                        changeDetection: i0.ChangeDetectionStrategy.Default,
                    }]
            }], propDecorators: { cdkTable: [{
                    type: i0.HostBinding,
                    args: ['class.cdk-table']
                }], table: [{
                    type: i0.HostBinding,
                    args: ['class.table']
                }], hover: [{
                    type: i0.HostBinding,
                    args: ['class.table-hover']
                }, {
                    type: i0.Input
                }] } });

    /**
     * Column that simply shows text content for the header and row cells. Assumes that the table
     * is using the native table implementation (`<table>`).
     *
     * By default, the name of this column will be the header text and data property accessor.
     * The header text can be overridden with the `headerText` input. Cell values can be overridden with
     * the `dataAccessor` input. Change the text justification to the start or end using the `justify`
     * input.
     */
    var NgbTextColumn = /** @class */ (function (_super) {
        __extends(NgbTextColumn, _super);
        function NgbTextColumn() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NgbTextColumn;
    }(i1.CdkTextColumn));
    NgbTextColumn.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbTextColumn, deps: null, target: i0__namespace.ɵɵFactoryTarget.Component });
    NgbTextColumn.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: NgbTextColumn, selector: "ngb-text-column", usesInheritance: true, ngImport: i0__namespace, template: "\n    <ng-container ngbColumnDef>\n      <th ngb-header-cell *ngbHeaderCellDef [style.text-align]=\"justify\">\n        {{ headerText }}\n      </th>\n      <td ngb-cell *ngbCellDef=\"let data\" [style.text-align]=\"justify\">\n        {{ dataAccessor(data, name) }}\n      </td>\n    </ng-container>\n  ", isInline: true, directives: [{ type: NgbColumnDef, selector: "[ngbColumnDef]", inputs: ["ngbColumnDef"] }, { type: NgbHeaderCellDef, selector: "[ngbHeaderCellDef]" }, { type: NgbHeaderCell, selector: "ngb-header-cell, th[ngb-header-cell]" }, { type: NgbCellDef, selector: "[ngbCellDef]" }, { type: NgbCell, selector: "ngb-cell, td[ngb-cell]", inputs: ["whiteSpace"] }], changeDetection: i0__namespace.ChangeDetectionStrategy.Default, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: NgbTextColumn, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngb-text-column',
                        template: "\n    <ng-container ngbColumnDef>\n      <th ngb-header-cell *ngbHeaderCellDef [style.text-align]=\"justify\">\n        {{ headerText }}\n      </th>\n      <td ngb-cell *ngbCellDef=\"let data\" [style.text-align]=\"justify\">\n        {{ dataAccessor(data, name) }}\n      </td>\n    </ng-container>\n  ",
                        encapsulation: i0.ViewEncapsulation.None,
                        // Change detection is intentionally not set to OnPush. This component's template will be provided
                        // to the table to be inserted into its view. This is problematic when change detection runs since
                        // the bindings in this template will be evaluated _after_ the table's view is evaluated, which
                        // mean's the template in the table's view will not have the updated value (and in fact will cause
                        // an ExpressionChangedAfterItHasBeenCheckedError).
                        // tslint:disable-next-line:validate-decorators
                        changeDetection: i0.ChangeDetectionStrategy.Default,
                    }]
            }] });

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    var EXPORTED_DECLARATIONS = [
        // Table
        NgbTable,
        NgbRecycleRows,
        // Template defs
        NgbHeaderCellDef,
        NgbHeaderRowDef,
        NgbColumnDef,
        NgbCellDef,
        NgbRowDef,
        NgbFooterCellDef,
        NgbFooterRowDef,
        // Cell directives
        NgbHeaderCell,
        NgbCell,
        NgbFooterCell,
        // Row directives
        NgbHeaderRow,
        NgbRow,
        NgbFooterRow,
        NgbNoDataRow,
        NgbTextColumn
    ];
    var DfxTableModule = /** @class */ (function () {
        function DfxTableModule() {
        }
        return DfxTableModule;
    }());
    DfxTableModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: DfxTableModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    DfxTableModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: DfxTableModule, declarations: [
            // Table
            NgbTable,
            NgbRecycleRows,
            // Template defs
            NgbHeaderCellDef,
            NgbHeaderRowDef,
            NgbColumnDef,
            NgbCellDef,
            NgbRowDef,
            NgbFooterCellDef,
            NgbFooterRowDef,
            // Cell directives
            NgbHeaderCell,
            NgbCell,
            NgbFooterCell,
            // Row directives
            NgbHeaderRow,
            NgbRow,
            NgbFooterRow,
            NgbNoDataRow,
            NgbTextColumn
        ], imports: [i1.CdkTableModule], exports: [
            // Table
            NgbTable,
            NgbRecycleRows,
            // Template defs
            NgbHeaderCellDef,
            NgbHeaderRowDef,
            NgbColumnDef,
            NgbCellDef,
            NgbRowDef,
            NgbFooterCellDef,
            NgbFooterRowDef,
            // Cell directives
            NgbHeaderCell,
            NgbCell,
            NgbFooterCell,
            // Row directives
            NgbHeaderRow,
            NgbRow,
            NgbFooterRow,
            NgbNoDataRow,
            NgbTextColumn
        ] });
    DfxTableModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: DfxTableModule, imports: [[i1.CdkTableModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: DfxTableModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        imports: [i1.CdkTableModule],
                        exports: [EXPORTED_DECLARATIONS],
                        declarations: EXPORTED_DECLARATIONS,
                    }]
            }] });

    /*
     * Public API Surface of dfx-bootstrap-table
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DfxTableModule = DfxTableModule;
    exports.MAT_SORT_DEFAULT_OPTIONS = MAT_SORT_DEFAULT_OPTIONS;
    exports.NgbCell = NgbCell;
    exports.NgbCellDef = NgbCellDef;
    exports.NgbColumnDef = NgbColumnDef;
    exports.NgbFooterCell = NgbFooterCell;
    exports.NgbFooterCellDef = NgbFooterCellDef;
    exports.NgbFooterRow = NgbFooterRow;
    exports.NgbFooterRowDef = NgbFooterRowDef;
    exports.NgbHeaderCell = NgbHeaderCell;
    exports.NgbHeaderCellDef = NgbHeaderCellDef;
    exports.NgbHeaderRow = NgbHeaderRow;
    exports.NgbHeaderRowDef = NgbHeaderRowDef;
    exports.NgbNoDataRow = NgbNoDataRow;
    exports.NgbRecycleRows = NgbRecycleRows;
    exports.NgbRow = NgbRow;
    exports.NgbRowDef = NgbRowDef;
    exports.NgbSort = NgbSort;
    exports.NgbSortHeader = NgbSortHeader;
    exports.NgbSortModule = NgbSortModule;
    exports.NgbTable = NgbTable;
    exports.NgbTableDataSource = NgbTableDataSource;
    exports.NgbTextColumn = NgbTextColumn;
    exports._NgbTableDataSource = _NgbTableDataSource;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=dfx-bootstrap-table.umd.js.map
